-- zgfx.e
-- ZIG screen drawing stuff

include image.e

global atom UL, UR, LL, LR, H, V
    -- Constants for Box()
    -- charset 1 \/
    --UL = 218 UR = 191 LL = 192 LR = 217 V = 179 H = 196
    -- charset 2 \/
    UL = 192 UR = 193 LL = 194 LR = 195 H = 196 V = 197
    
global constant
    NUM = 1, CHAR = 2, COL = 3


global function SaveScreen()
    return(save_text_image({1, 1}, {25, 80}))
end function

global procedure ResScreen(sequence Screen)
    display_text_image({1, 1}, Screen)
end procedure

global procedure egamode()
    -- Get into EGA textmode (350 scanlines, ZZT-style)
    sequence regs
    regs = repeat(0, 10)
    regs[REG_AX] = #1201
    regs[REG_BX] = #0030
    regs = dos_interrupt(#10, regs)
    regs[REG_AX] = #0003
    regs = dos_interrupt(#10, regs)    
end procedure

global procedure InvertArea(atom X1, atom Y1, atom X2, atom Y2)
    sequence i
    
    i = save_text_image({X1, Y1}, {X2, Y2})
    for z = 1 to length(i) do
        for a = 1 to length(i[z]) by 2 do
            i[z][a + 1] = i[z][a + 1] + 16
        end for
    end for
    
    display_text_image({X1, Y1}, i)
end procedure

global procedure Box(atom X1, atom Y1, atom X2, atom Y2, atom BoxColor, sequence Cap) 
    atom ISizeX, ISizeY
    sequence PutLine1, PutLine2, Spaces
    
    ISizeX = (X2 - X1) - 2
    ISizeY = (Y2 - Y1) - 1
    PutLine1 = repeat(H, ISizeY)
    PutLine1 = prepend(PutLine1, UL)
    PutLine1 = append(PutLine1, UR)
    PutLine2 = repeat(H, ISizeY)
    PutLine2 = prepend(PutLine2, LL)
    PutLine2 = append(PutLine2, LR)
    Spaces = repeat(32, ISizeY)
    Spaces = prepend(Spaces, V)  Spaces = append(Spaces, V)
    
    text_color(14)
    bk_color(BoxColor)
    position(X1, Y1)
    puts(1, PutLine1)
    position(X2, Y1)
    puts(1, PutLine2)
    
    for X = X1 + 1 to X2 - 1 do
        position(X, Y1)
        puts(1, Spaces)
    end for
    
    text_color(15)
    bk_color(BoxColor)
    position(X1, Y1 + 1)
    puts(1, Cap)
end procedure

global procedure color(atom Fore, atom Back)
    if Back < 8 then
        text_color(Fore)
        bk_color(Back)
    else
        text_color(Fore + 16)
        bk_color((Back - 8))
    end if
end procedure

global function ColAttrib(atom Cf, atom Cb)
    return((Cb * 16) + Cf)
end function

-- Return a foreground color from a single-atom color element
global function CGetFore(atom C)
    while C - 16 > 0 do
        C = C - 16
    end while
    
    return C
end function

-- Return a background color from a single-atom color element
global function CGetBack(atom C)
    atom Cn
    Cn = 0

    while C - 16 > 0 do
        C = C - 16
        Cn = Cn + 1
    end while
    
    return Cn
end function

global procedure text_at(atom x, atom y, sequence t, atom c)
    position(x, y)
    text_color(c)
    puts(1, t)
end procedure

